#include <string.h>
#include <stdlib.h>
#include <curses.h>
#include <unistd.h>
#include "ruutu.h"
#include "mcform.h"
#include <paths.h>

extern void do_background(char *);
extern void do_devo(char *);
extern void do_glue(char *);
extern void do_stats(char *);
extern void do_devo(char *);

extern "C" {
  char *do_name(void);
  void do_profe(char *);
  void do_race(char *);
  void do_skills(char *);
  char *mstrtok(char *,char *);
};

extern void do_raise(char *, char *);

void put_charru(void)
{
  char teksti[80];
  int tmp;
  int rivi=0;

  clear();
  move(0,0);
  refresh();
  my_box(0,0,22,79);
  move(6,25);
  attron(A_UNDERLINE);
  move(6,25);
  printw("Role-Char Developer V6.0");
  move(6,49);
  attroff(A_UNDERLINE);
  move(9,35);
  printw("by");
  move(12,27);
  printw("Mauri");
  move(12,33);
  printw("\"mos\"");
  move(12,41);
  printw("Sahlberg");
  move(15,16);
  attron(A_BOLD);
  move(15,16);
  printw("(C)opyright by Mauri Sahlberg, Helsinki 1992");
  move(15,60);
  attroff(A_BOLD);
  move(21,2);
  attron(A_REVERSE);
  move(21,2);
  printw("Press any key to start!");
  move(21,25);
  attroff(A_REVERSE);
  printw(" ");
  refresh();
}

void put_copy(void)
{
  char teksti[80];
  int tmp;
  int rivi=0;

  clear();
  move(0,0);
  refresh();
  my_box(1,26,3,37);
  move(2,27);
  attron(A_BLINK);
  move(2,27);
  printw("ATTENTION!");
  move(2,37);
  attroff(A_BLINK);
  move(5,0);
  printw("This");
  move(5,5);
  printw("program");
  move(5,13);
  printw("is");
  move(5,16);
  printw("indented");
  move(5,25);
  printw("for");
  move(5,29);
  printw("making");
  move(5,36);
  attron(A_BOLD);
  move(5,36);
  printw("Rolemaster");
  move(5,46);
  attroff(A_BOLD);
  move(5,46);
  printw("(");
  move(5,47);
  attron(A_BOLD);
  move(5,47);
  printw("tm");
  move(5,49);
  attroff(A_BOLD);
  move(5,49);
  printw(")");
  move(5,51);
  printw("characters");
  move(5,62);
  printw("only.");
  move(6,0);
  printw("Any");
  move(6,4);
  printw("use");
  move(6,8);
  printw("that");
  move(6,13);
  printw("might");
  move(6,19);
  printw("violate");
  move(6,27);
  attron(A_BOLD);
  move(6,27);
  printw("Iron");
  move(6,31);
  attroff(A_BOLD);
  move(6,32);
  attron(A_BOLD);
  move(6,32);
  printw("Crown");
  move(6,37);
  attroff(A_BOLD);
  move(6,38);
  attron(A_BOLD);
  move(6,38);
  printw("Enterprises");
  move(6,49);
  attroff(A_BOLD);
  move(6,50);
  attron(A_BOLD);
  move(6,50);
  printw("inc ");
  move(6,54);
  attroff(A_BOLD);
  move(6,54);
  printw("copyright");
  move(6,64);
  printw("for");
  move(7,0);
  printw("Rolemaster(tm)");
  move(7,15);
  printw("is");
  move(7,18);
  printw("strickly");
  move(7,27);
  printw("forbidden.");
  move(9,0);
  printw("To");
  move(9,3);
  printw("obtain");
  move(9,10);
  printw("full");
  move(9,15);
  printw("potential");
  move(9,25);
  printw("of");
  move(9,28);
  printw("the");
  move(9,32);
  printw("program");
  move(9,40);
  printw("you");
  move(9,44);
  printw("should");
  move(9,51);
  printw("have");
  move(9,56);
  printw("Rolemaster(tm)");
  move(10,0);
  printw("books:");
  move(10,7);
  printw("Boxed");
  move(10,13);
  printw("Set");
  move(10,17);
  printw("and");
  move(10,21);
  printw("Companion");
  move(10,31);
  printw("II.");
  move(10,35);
  printw("Other");
  move(10,41);
  printw("Companions");
  move(10,52);
  printw("I-V,");
  move(10,57);
  printw("Elemental");
  move(10,67);
  printw("and");
  move(11,0);
  printw("Spellusers");
  move(11,11);
  printw("Companion");
  move(11,21);
  printw("are");
  move(11,25);
  printw("also");
  move(11,30);
  printw("helpful.");
  move(16,0);
  attron(A_BOLD);
  move(16,0);
  printw("Rolemaster ");
  move(16,11);
  attroff(A_BOLD);
  move(16,11);
  printw("is");
  move(16,14);
  printw("trademark");
  move(16,24);
  printw("registered");
  move(16,34);
  attron(A_BOLD);
  move(16,34);
  printw(" ");
  move(16,35);
  attroff(A_BOLD);
  move(16,35);
  printw("to");
  move(16,37);
  attron(A_BOLD);
  move(16,37);
  printw(" Iron Crown Enterprises inc.");
  move(16,65);
  attroff(A_BOLD);
  move(17,0);
  attron(A_BOLD);
  move(17,0);
  printw("Copyright");
  move(17,9);
  attroff(A_BOLD);
  move(17,10);
  printw("holder");
  move(17,17);
  printw("of");
  move(17,20);
  attron(A_BOLD);
  move(17,20);
  printw("Rolemaster");
  move(17,30);
  attroff(A_BOLD);
  move(17,31);
  printw("books ");
  move(17,38);
  printw("is");
  move(17,41);
  attron(A_BOLD);
  move(17,41);
  printw("Iron Crown Enterprises");
  move(17,63);
  attroff(A_BOLD);
  move(17,64);
  attron(A_BOLD);
  move(17,64);
  printw("inc.");
  move(17,68);
  attroff(A_BOLD);
  move(22,0);
  attron(A_BOLD);
  attron(A_REVERSE);
  move(22,0);
  printw("Press any key to continue!");
  move(22,26);
  attroff(A_BOLD);
  attroff(A_REVERSE);
  move(22,27);
  printw(" ");
  refresh();
}

int main(int ac, char **av)
{
  int lvl=0;
  char *name=NULL;
  FILE *src = NULL;
  int i=0;
  int clvl=0;
  char *filename=NULL;
  int len=0;
  char *nimi=NULL;
  char *spent=NULL;
  char *hillo=NULL;

  if(ac < 2 || ac > 3) {
    printf("Usage: %s <target_level> [charname]\n", av[0]);
    return 1;
  }


  lvl = atoi(av[1]);
  if(lvl < 0 || lvl > 100) {
    printf("Level requested is rather strange! (%i)\n",lvl);
    return 1;
  }  

  falku();
  put_charru();
  getch();
  put_copy();
  getch();

  if(ac == 3)
    name = av[2];
  else
    name = do_name();

  if(!name) {
    printf("Your character doesn't have name!\n");
    return 1;
  }

  len = strlen(SAVE) + strlen(name) * 2 +16;
  filename = (char *)malloc(len);

  if(!filename) {
    perror("charru.cc/main()");
    return 0;
  }

  hillo = mstrtok(name," \n\0");
  sprintf(filename,"%s/%s/.lvl",SAVE,hillo);
  
  src = fopen(filename,"r");
  if(src) {
    clvl = getw(src);
    fclose(src);
  }

  if(!clvl) {
    do_stats(name);
    do_profe(name);
    do_race(name);
    do_background(name);
    do_skills(name);
    do_devo(name);
  }

  src = fopen(filename,"r");
  if(src) {
    clvl = getw(src);
    fclose(src);
  }


  len = strlen(SAVE) + strlen(name) * 2 +16;
  nimi = (char *)malloc(len);

  if(!nimi) {
    perror("charru.cc/main()");
    return 0;
  }

  len = strlen(SAVE) + strlen(name) * 2 + 16;
  spent = (char *)malloc(len);

  if(!spent) {
    perror("charru.cc/main()");
    return 0;
  }
  
  sprintf(nimi,"%s/%s/%s.fstats",SAVE,name,name);
  sprintf(spent,"%s/%s/.spent",SAVE,name);

  for(i=clvl;i<=lvl;i++) {       
    do_raise(nimi,filename);    
    unlink(spent);
    do_devo(name);
    src = fopen(filename,"r");
    if(src) {
      i = getw(src);
      fclose(src);
    }
  }
  free(nimi);
  free(filename);
  do_glue(name);
  return 0;
}

